package sav.example.javaz;
import sav.z.*;
import java.io.*;
/**
 * This example is typical use of basic Session, Variable and Base
 * classes.
 */
public class TypicalDemo {
  public static void main(String arg[]) throws IOException {
    String script =
      "$base 'CompanyX'~;" +
      "$readTable() <" +
      "employee; name;           department; salary \n" +
      "101;      'Adams Smith';  1;          50000 \n" +
      "102;      'Clark White';  1;          30000 \n" +
      "103;      'Jones Hunter'; 2;          60000 \n" +
      "104;      'Blake Dull';   3;          65000 \n" +
      "105;      'Sylvia Smith'; 1;          25000 \n" +
      "108;      'Albert Green'; 3;          40000 \n" +
      "109;      'Clark Ringer'; 2;          50000 \n" +
      ">;"
    ;
    Session ss = new Session();
    ss.z(script);

    /* The $x variable forming via Zigzag script */
    ss.exploreBase("CompanyX");
    script = "$x = employee:(salary:30000^);";
//    ss.setFailExcepted(true);
    if (ss.z(script) == 0) {
      System.out.println("Failure for " + script);
      return;
    }

    /* The $y variable forming in the Java cycle */
 //   Base base = ss.base();
    Variable vx = ss.var("x");
    Variable vy = ss.var("y");
    int max = 3;
    int n = 0;
    for (String emp = vx.first(); emp != null; emp = vx.next(emp)) {
      vy.add(emp);
      if (++n == max)
        break;
    }

    /* Printing the $x variable contents */
    Printer prt = new WPrinter(new PrintWriter(System.out));
    //Printer prt = new ConsolePrinter();
    ss.setReportPrinter(prt);
    prt.println("--- 3 potential workers  ---");
    ss.z("$pt($y)");
    prt.flush();
  }
}
